BASEDIR=${1:-..}
INDIR=$BASEDIR/results
OUTDIR=$BASEDIR/collected
TMP=$OUTDIR/tmp

rm -rf $TMP
mkdir -p $TMP

sched=`find $INDIR -maxdepth 1 -mindepth 1 -exec basename \{\} \;`

for sc in $sched ; do
  echo -\> SCHEDULER $sc --------

  if [ $sc == "cfq" ] ; then
	twait=/
  else
  	twait=`find $INDIR/$sc -maxdepth 1 -mindepth 1 -exec basename \{\} \;` 
  fi
  for tw in $twait ; do
    tw_num=`echo $tw | sed -e s/T_wait//g -e s:/:X:g`
    echo ---\> TWAIT $tw ----------
    skew=`find $INDIR/$sc/$tw -maxdepth 1 -mindepth 1 -iname "skew*"\
	-exec basename \{\} \; | sed s/skew//g`
    for sk in $skew ; do
      echo -----\> SKEW $sk ---------
      nfiles=`find $INDIR/$sc/$tw/skew$sk -maxdepth 2 \
	-mindepth 2 -exec basename \{\} \; | \
	sed "s/nfiles\([0-9]*\)-iter[0-9]*/\1/g" | sort | uniq`
      for nf in $nfiles ; do
        echo -------\> NFILES $nf ------
        for dir in $INDIR/$sc/$tw/skew$sk/*/nfiles${nf}-iter* ; do
          echo ---------\> $dir ----------
          for f in $dir/* ; do
            if test -f $f ; then
	      if [[ $f == *_iostat ]] ; then
		awk '/hdb/{print $3}' $f | sh gen_stats.sh 95 | awk '{print $3}' >>\
		  $TMP/${sc}-twait-${tw_num}-skew-${sk}-nfiles-${nf}-`basename $f`
		awk '/hdb/{print $3}' $f | tail -n 5 | sh gen_stats.sh 95 | \
		  awk '{print $3}' >>\
		  $TMP/${sc}-twait-${tw_num}-skew-${sk}-nfiles-${nf}-`basename $f`last
		awk '/hdb/{print $3}' $f | tail -n 2 | head -n 2 >> \
		  $TMP/${sc}-twait-${tw_num}-skew-${sk}-nfiles-${nf}-`basename $f`last2
	      else
                cat $f >> $TMP/${sc}-twait-${tw_num}-skew-${sk}-nfiles-${nf}-`basename $f`
	      fi
            fi
          done
	  if [ "$2" == "noparse" ] ; then
            for g in $dir/single_logs/* ; do
	      delayfile=`echo $g | sed -e 's:single_logs/::' -e 's/thr/delay/' \
		-e 's/[-]file.*//'`
	      delay=`cat $delayfile`
              awk "{print \$1 / 1024 / 1024 / $delay }" $g >> $TMP/${sc}-twait-${tw_num}-skew-${sk}-nfiles-${nf}-single-`basename $g`
	    done
	  else
            for g in $dir/single_logs/* ; do
              awk '/seconds/{print $1 / 1024 / 1024 / $6}' $g >> $TMP/${sc}-twait-${tw_num}-skew-${sk}-nfiles-${nf}-single-`basename $g`
            done
	  fi
        done
      done
    done
  done
done
