# generate tables (NOTE still does not handle CFQ)
#
BASEDIR=${1:-..}
OUTDIR=$BASEDIR/collected
RAW=$OUTDIR/raw
TBL=$OUTDIR/tbl

rm -rf $TBL
mkdir -p $TBL

# each input file contains a row, this script finds out the table it
# belongs to (for bfq row indexes are budget values, for cfq file sizes)
#
AWK_PROCNAME='
/(cfq|bfq|yfq|scanedf)-.*single-thr/ {
	# bfq-twait-4-skew-0-nfiles-2-single-thr_log-128M-b1024-file0
	printf "%s-tw-%s-skew-%s-nfiles-%s-single-%s-%s", $1, $3, $5, $7, $10, $12
}
/(cfq|bfq|yfq|scanedf)-.*(agg_thr|delay|videos|iostat.*)/ {
	# bfq-twait-4-skew-0-nfiles-2-agg_thr_log-128M-b1024
	# bfq-twait-4-skew-0-nfiles-2-delay_log-128M-b1024
	printf "%s-tw-%s-skew-%s-nfiles-%s-%s-%s", $1, $3, $5, $7, $8, $9
}'

AWK_INDEX='
/(cfq|bfq|yfq|scanedf)-.*single-thr/ {
	# bfq-twait-4-skew-0-nfiles-2-single-thr_log-128M-b1024-file0
	print substr($11, 2)
}
/(cfq|bfq|yfq|scanedf)-.*(agg_thr|delay|videos|iostat.*)/ {
	# bfq-twait-4-skew-0-nfiles-2-agg_thr_log-128M-b1024
	print substr($10, 2)
}'

for f in $RAW/* ; do
	b=`basename $f`
	n=`echo $b | awk -F- "$AWK_PROCNAME"`
	idx=`echo $b | awk -F- "$AWK_INDEX"`
	if [ ! -z "$n" ] ; then
		echo -e "$idx\t`cat $f`" >> $TBL/$n.tmp
	fi
done

for f in $TBL/*.tmp ; do
	sort -nk1 < $f > ${f/.tmp/}
	rm $f
done

