# generate tables
BASEDIR=${1:-..}
OUTDIR=$BASEDIR/collected
RAW=$OUTDIR/raw
TBL=$OUTDIR/tbl
TEX=$OUTDIR/tex

rm -rf $TEX
mkdir -p $TEX

sched="cfq bfq scanedf yfq"

function print_heading() {
  if [ "$sc" == "bfq" ] ; then var="Max Budget (sectors)" ;
  elif [ "$sc" == "yfq" ] ; then var="Batch (requests)" ;
  elif [ "$sc" == "scanedf" ] ; then var="Granularity (ms)" ; fi
  if [ "$type" == "delay_log" ] ; then unit="(s)" ;
  elif [ "$type" == "agg_thr_log" ] ; then unit="(MB/s)" ; fi
  echo $var '& Min' $unit '& Max' $unit '& Avg' $unit '& Conf' $unit '\\\\ \hline\hline'
}

for sc in $sched ; do
  echo -\> SCHEDULER $sc --------
  twait=`find $TBL -name "${sc}*" | awk -F- '{print $3}' | sort | uniq`
  for tw in $twait ; do
    echo ---\> TWAIT $tw ----------
    skew=`find $TBL -name "${sc}-tw-${tw}*" | awk -F- '{print $5}' | sort | uniq`
    for sk in $skew ; do
      echo -----\> SKEW $sk ---------
      nfiles=`find $TBL -name "${sc}-tw-${tw}-skew-${sk}*" | awk -F- '{print $7}' | sort | uniq`
      for nf in $nfiles ; do
        echo -------\> NFILES $nf ------
	sizes=`find $TBL -name "${sc}-tw-${tw}-skew-${sk}-nfiles-${nf}*" | awk -F- '{print substr($9, 1, 3)}' | sort | uniq`
	for size in $sizes ; do
	  for type in agg_thr_log delay_log ; do
	    in=$TBL/${sc}-tw-${tw}-skew-${sk}-nfiles-${nf}-${type}-${size}M
	    out=$TEX/${sc}-tw-${tw}-skew-${sk}-nfiles-${nf}-${type}-${size}M.tex
	    echo "\begin{tabular}{|r||r|r|r|r|}\hline" >> $out
	    print_heading >> $out
	    awk '{printf "%s & %s & %s & %s & %s \\\\ \\hline\n", $1, $2, $3, $4, $5}' $in >> $out
	    echo "\end{tabular}" >> $out
	  done
	  budgets=`awk '{print $1}' $TBL/${sc}-tw-${tw}-skew-${sk}-nfiles-${nf}-single-${size}M-file0`
	  for bg in $budgets ; do
	    if [ "$sc" == "bfq" ] ; then u="b" ;
	    elif [ "$sc" == "yfq" ] ; then u="b" ;
	    elif [ "$sc" == "scanedf" ] ; then u="g" ; 
	    elif [ "$sc" == "cfq" ] ; then u="s" ; fi

	    in=$RAW/${sc}-twait-${tw}-skew-${sk}-nfiles-${nf}-single-thr_log-${size}M-${u}${bg}
	    out=$TEX/${sc}-tw-${tw}-skew-${sk}-nfiles-${nf}-${size}M-${u}${bg}-fairness.tex
	    echo "\begin{tabular}{|r||r|r|r|r|}\hline" >> $out
	    echo '& Min (MB/s) & Max (MB/s) & Avg (MB/s) & Conf (MB/s) \\\\ \hline\hline' >> $out
	    for ((i=0;i<$nf;i++)) ; do
	      in1=${in}-file${i}
	      awk '{printf "Process %s & %s & %s & %s & %s \\\\ \\hline\n", '$i',$1, $2, $3, $4}' ${in1} >> $out
	    done
	    echo '\end{tabular}' >> $out
	  done
	done
      done
    done
  done
done

