. conf.sh

out_file=$1

# time to wait between video submissions
#
VLC_VIDEO_DELAY=15

# number of sarted video playbacks
#
num_started=0

# maximum packet loss precentage accepted (x 1000)
#
MAX_LOSS=1000

# start to broadcast $1, using netcat to send data towards the
# telnet interface
#
function play() {
	echo -e "videolan\ncontrol $1 play\nquit\n" | nc 127.0.0.1 4212 > /dev/null
}

function shutdown() {
	ssh vlc@gror killall nc
	killall vlc
	rm -f vlm_bcast.cfg
	rm -f vlc_listen.sh
}

# check if there is any underrun, if so, print the maximum number of
# videos that were playing BEFORE trying to add the last one
#
function check() {
	if grep "MAX_LOSS_RATE exceeded" vlc.log > /dev/null ; then
		shutdown
		echo $num_started VIDS
		echo $num_started VIDS > $out_file
		exit 0
	fi

	num_started=$((num_started+1))
}

echo Cleaning up and preventively shutting down possible still alive processes ...
shutdown

for f in $FILES ; do
	nr=${f/:*/}
	ofs=${nr/v/}
	vid=${f/*:/}
	echo new $nr broadcast enabled >> vlm_bcast.cfg
	echo setup $nr input $vid >> vlm_bcast.cfg
	echo "setup $nr output #std{access=udp,mux=ts,url=10.30.3.66:$((5554+$ofs))}" >> vlm_bcast.cfg
	echo "nc -l -u -p $((5554+$ofs)) > /dev/null &" >> vlc_listen.sh
#	echo control $nr play >> vlm_bcast.cfg
done

echo Starting remote listeners...
scp vlc_listen.sh vlc@gror:
ssh -f vlc@gror 'sh vlc_listen.sh'

echo Starting VLC...
/usr/local/bin/vlc --ttl 12 -vvv --vlm-conf=vlm_bcast.cfg -I telnet --telnet-password videolan --sout-udp-loss $MAX_LOSS > vlc.log 2>&1 &

echo Waiting for vlc to settle...
sleep $VLC_SETUP_DELAY

for f in $FILES ; do
	nr=${f/:*/}
	echo Starting $nr
	play $nr
	sleep $VLC_VIDEO_DELAY
	check
done

echo Shutting down...
shutdown
echo NO MORE FILES TO PLAY
echo INF VIDS > $out_file

